

'TEST ok

CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency

' Pin configuration for MAX_3040 (RS-485)
  RS_DI = 3
  RS_DE = 4
  RS_RE = 5
  RS_RO = 6
  
  
OBJ
    
  ser : "Extended_FDSerial"    'For debug and serial com
  ser2 : "SerialMirror-Test"
  'max1270:  "Max1270"           'ADC interface
  heart : "heartbeat"     'object that makes an LED blink for showing propeller-chip is alive and working

CON
  MaxStrLength = ser2#buffer_length
    
VAR

  LONG Chan
  Byte Range 
  Byte Bip
  Byte MyStr[MaxStrLength]
  
PUB Test_serial | x,ptr,ptr2 'rs485  

  heart.Start(9,250) 'blinking on PIN 9 as Lifesignal of PropellerChip

' configuration par dfaut des ADAM : 9600bauds et 10bits 
    'ser.start(RS_RO, RS_DI, 0, 9600)
    ser.start(31, 30, 0, 9600)
    'ser2.init(RS_RO, RS_DI, 9600)  
    'ser2.start(RS_RO, RS_DI, 0, 9600)       
    ser2.start(26, 25, 0, 9600)       

    repeat
      'waitcnt(clkfreq*2+cnt)
      x := 0
      MyStr[0] := 0                                  'set all byte of mystr to 0
     'this line stores zeros in the WHOLE string
     'latest after that EVERY byte in MyStr should be deleted
      bytefill(@MyStr,0,MaxStrLength - 1)                                            

     'I assume that this codelines start the sending of the string
     'so before executing these lines you can delete the rxbuffer by calling
      ser2.RxFlush 'to make sure that there is nothing left in the rxbuffer
      'when you start to receive the new command  
     'Etat d'coute
      LOW(RS_RE)
      LOW(RS_DE)    
                                            
      ser.str(string("wait to receive string on ser2",13))
      ser2.RxStr(@MyStr)

      HIGH (RS_DE)

      ser.str(string("string received written next line between < and >",13))
      ser.str(string("<"))
      ser.str(@MyStr)
      ser.str(string(">"))
      ser.tx(13)
      ser.tx(13)
      waitcnt(clkfreq/100 + cnt)
      ser.tx(13)
 

PUB TestADC|v    'the first PUB routine is assumed the be the main one
'Paramtres par dfaut du max 1270

  Chan := 0
  Range := true
  Bip := false


  ser.start(31, 30, 0, 9600)
  
  
  repeat
    ser.str(string(13,"MilliVolts: "))
    
    
    'v:=max1270.get_millivolts(Chan, Range, Bip   )
    'show
    ser.dec(v)

PUB HIGH(Pin)
    dira[Pin]~~
    outa[Pin]~~
         
PUB LOW(Pin)
    dira[Pin]~~
    outa[Pin]~
    